% $Id: MailboxExtraTest.oz,v 1.2 2009/11/08 23:56:43 leavens Exp leavens $
% Tests for Exercise 9 (Problem 7 in chapter 5 of CTM) with timeouts
\insert 'MailboxTest.oz'
declare
%% Bodies for timeouts,
%% note that this is a zero-argument procedure, contrary to the book!
fun {Timedout} timedout end

{StartTesting 'Mailbox extra credit'}

%% Note that timeout procedures (like Timedout) are zero-argument procedures
{StartTesting 'Receive with nonzero timeout'}
MB={Mailbox.new}
thread {Delay 1000} {Mailbox.send MB 99} end
thread {Delay 4000} {StartTesting 'sending 5'} {Mailbox.send MB 5} end
thread {Delay 7000} {StartTesting 'sending 72'} {Mailbox.send MB 72} end
{Test {Mailbox.receive MB [{Equals 99}#Id] 20#Timedout} '==' timedout}
{Test {Mailbox.receive MB [{Equals 72}#Id] 2000#Timedout} '==' timedout}
{Test {Mailbox.receive MB [{Equals 5}#Id] infinity} '==' 5}
{Test {Mailbox.receive MB [{Equals 72}#Id] 40000#Timedout} '==' 72}
{Test {Mailbox.receive MB [{Equals 99}#Id] infinity} '==' 99}

{StartTesting 'Receive with zero timeout'}
{Mailbox.send MB 27}
{Mailbox.send MB 42}
{Test {Mailbox.receive MB [{Equals 42}#Id] 0#Timedout} '==' 42}
{Test {Mailbox.receive MB [{Equals 27}#Id] 0#Timedout} '==' 27}
{Test {Mailbox.receive MB [{Equals 313}#Id] 0#Timedout} '==' timedout}

{StartTesting 'Mailbox Extra All done'}
